/**
 * 
 */
package com.bukkitarena;

import java.io.File;
import java.lang.reflect.Field;
import java.lang.reflect.Modifier;

import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;


/**
 * @author Nate Mortensen
 * 
 * 
 *         Once again, a derivative of what I like to call the md_5 loading
 *         method.
 */
public class Msg {
    public static String CLASS_SELECT_FAIL = "Unable to select <class>";
    public static String CLASS_SELECT_FAIL_NOPERM = "You don't have permission for <class>";
    public static String CLASS_SELECT_SUCCESS = "You selected <class> as your class.";

    public static String LOBBY_JOIN = "Welcome!";
    public static String LOBBY_JOIN_PREVOTE = "Voting will begin when there are <minplayers> players in this lobby.";
    public static String LOBBY_JOIN_PREGAME = "<type> has been selected as the Arena Type, and <arena> as the Arena.";
    public static String LOBBY_JOIN_VOTING_ARENA = "Voting has already begun!  Vote for an Arena!";
    public static String LOBBY_JOIN_VOTING_TYPE = "<Arena> has already been selected!  Vote for a type!";
    public static String LOBBY_JOIN_FAIL = "Unable to join lobby.";
    public static String LOBBY_JOIN_FAIL_FULL = "Sorry, that lobby is full.";
    public static String LOBBY_VOTE_START = "The following options can be voted for: ";
    public static String LOBBY_VOTE_CHECK_FAIL_MOREVOTE = "More players need to vote to start the game!";
    public static String LOBBY_VOTE_CHECK_SUCCESS_TIME = "Enough time has passed, winning results will be selected from all current votes.";
    public static String LOBBY_VOTE_CHECK_SUCCESS_VOTES = "Enough players have voted, winning results will now be selected from all current votes.";
    public static String LOBBY_VOTE_TIE = "There was a tie!  Now shuffling the voting for another round.";
    public static String LOBBY_VOTE_ARENA_START = "Vote for one of the following arenas:";
    public static String LOBBY_VOTE_SUCCESS = " You voted for ";
    public static String LOBBY_VOTE_TYPE_START = "<arena> has been selected!  Now vote for a game type!";
    public static String LOBBY_VOTE_TYPE_PRESELECT = "Enough votes have been cast!  Winning type will be selected in 5 seconds!";
    public static String LOBBY_VOTE_TYPE_SELECT = "<type> has been selected!";
    public static String LOBBY_VOTE_FAIL_SAME = "You're already voting for this choice.";
    public static String LOBBY_VOTE_FAIL_INVALID = "That's not an option you may vote for.";
    public static String LOBBY_START = "Arena starts in <second> seconds!";

    public static String ARENA_CHECK_FAIL_WAVESET = "Specified Arena Type requires a waveset.";
    public static String ARENA_CHECK_FAIL_SPAWNPOINTS = "Specified Arena Type requires spawnpoints.";
    public static String ARENA_CHECK_FAIL_CLASSSET = "Specified Arena Type requires a class set.";
    public static String ARENA_CHECK_FAIL_REQUIRED = "Specified Arena Type requires the following values be set: ";
    public static String ARENA_QUIT_FAIL = "You can't quit at this time.";
    public static String ARENA_QUIT_SUCCESS = "Thanks for playing!";
    public static String ARENA_ENTER_FAIL = "You can't walk into an arena.";
    public static String ARENA_LEAVE_FAIL = "You can't just leave the arena.";

    public static String PREFIX = "&f[&0Bukkit&4Arena&f]&7";

    FileConfiguration config;

    public Msg() {
        config = YamlConfiguration.loadConfiguration(new File(BukkitArena.getFolder() + "messages.yml"));
        load();
    }

    private void load() {
        loadPrefix();
        for (Field field : this.getClass().getDeclaredFields()) {
            if (Modifier.isStatic(field.getModifiers())) {
                String path = field.getName();
                try {
                    if (config.isSet(path)) {
                        field.set(this, PREFIX + config.get(path));
                    } else {
                        if (field.get(this) != null) {
                            config.set(path, field.get(this));
                        } 
                    }
                } catch (IllegalAccessException ex) {

                }
            }
        }
    }

    public void loadPrefix() {
        try {
            this.getClass().getField("PREFIX").set(this, config.getString("PREFIX", "&f[&0Bukkit&4Arena&f]"));
        } catch (IllegalArgumentException e) {
            e.printStackTrace();
        } catch (SecurityException e) {
            e.printStackTrace();
        } catch (IllegalAccessException e) {
            e.printStackTrace();
        } catch (NoSuchFieldException e) {
            e.printStackTrace();
        }
    }

}
