/**
 * 
 */
package com.bukkitarena.arena;

import java.io.File;
import java.util.List;

import org.bukkit.Location;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;

import com.bukkitarena.BukkitArena;
import com.bukkitarena.configuration.EasyConfiguration;
import com.bukkitarena.entity.ArenaEntity;
import com.bukkitarena.entity.ArenaPlayer;
import com.bukkitarena.util.SortedNamedObjectList;

/**
 * @author Nate Mortensen
 * 
 */
public class ArenaManager extends EasyConfiguration {

    SortedNamedObjectList<Arena> arenas = new SortedNamedObjectList<Arena>();

    public ArenaManager() {
        load(new File(BukkitArena.getFolder(), "arenas.yml"));
        for (String s : getConfig().getKeys(false))
            arenas.add(new Arena(getConfig().getConfigurationSection(s)));
    }

    public Arena getArena(String name) {
        return arenas.get(name);
    }

    public Arena getArena(Location l) {
        for (Arena a : arenas)
            if (a.getRegion().containsLocation(l))
                return a;
        return null;
    }

    public Arena getArena(Player p) {
        for (Arena a : arenas)
            if (a.containsPlayer(p))
                return a;
        return null;
    }

    public Arena getArena(LivingEntity e) {
        for (Arena a : arenas)
            if (a.getEntity(e) != null)
                return a;
        return null;
    }

    public List<Arena> getArenas() {
        return arenas.asList();
    }

    public boolean inArena(LivingEntity e) {
        return getArena(e) != null;
    }

    public ArenaPlayer getArenaPlayer(Player p) {
        if (inArena(p))
            return getArena(p).getPlayer(p);
        return null;
    }

    public ArenaEntity getArenaEntity(LivingEntity e) {
        if (inArena(e))
            return getArena(e).getEntity(e);
        return null;
    }

}
