/**
 * 
 */
package com.bukkitarena.arena;

import com.bukkitarena.BukkitArena;
import com.bukkitarena.spawning.Wave;
import com.bukkitarena.spawning.WaveSet;

/**
 * @author Nate Mortensen
 * 
 */
public class ArenaWaveManager {
    WaveSet set;
    long time;
    Arena arena;

    public ArenaWaveManager(String name, Arena a) {
        set = BukkitArena.getWaveManager().getWaveSet(name);
        arena = a;

    }

    public boolean isEmpty() {
        if (set == null)
            return true;
        return set.isEmpty();
    }

    public void spawnNextWave() {
        set.spawnNextWave(arena);
        time = System.currentTimeMillis();
    }

    public Wave getNextWave() {
        return set.getNextWave();
    }

    public long getTimeSinceLastWave() {
        return System.currentTimeMillis() - time;
    }

}
