/**
 * 
 */
package com.bukkitarena.arenatype;

import org.bukkit.command.CommandSender;

import com.bukkitarena.arena.Arena;
import com.bukkitarena.command.ArenaCommandExecutor;

/**
 * @author Nate Mortensen
 * 
 * 
 *         This is the class meant to be extended by developers.
 */
public abstract class ArenaType implements ArenaCommandExecutor {

    Arena arena;
    ArenaTypeManager manager;
    ArenaTypeDescriptionFile file;

    public boolean onCommand(CommandSender sender, String command, String[] args) {
        return false;
    }

    public abstract void onStart();

    public abstract void onEnd();

    public void initialize(Arena a, ArenaTypeManager m, ArenaTypeDescriptionFile f) {
        arena = a;
        manager = m;
        file = f;

    }

    /**
     * @return the arena
     */
    public Arena getArena() {
        return arena;
    }

    /**
     * @return the ArenaTypeManager.
     */
    public ArenaTypeManager getArenaTypeManager() {
        return manager;
    }

    public ArenaTypeDescriptionFile getDescription() {
        return file;
    }

    public String toString() {
        return file.getName();
    }

}
