/**
 * 
 */
package com.bukkitarena.command;

import java.util.ArrayList;

import org.bukkit.configuration.ConfigurationSection;

import com.bukkitarena.configuration.EasyConfiguration;
import com.bukkitarena.configuration.Load;

/**
 * @author Nate Mortensen
 * 
 */
public class CommandDescription extends EasyConfiguration {
    String cmd;
    @Load
    String help;
    @Load
    String aliasesString;

    String[] aliases;

    public CommandDescription(ConfigurationSection section) {
        load(section);
        cmd = section.getName();
        aliases = aliasesString.split(",");

    }

    public boolean containsCommand(String command) {
        for (String s : aliases)
            if (s.equalsIgnoreCase(command))
                return true;
        if (cmd.equalsIgnoreCase(command))
            return true;
        return false;
    }

    public static ArrayList<CommandDescription> loadCommandDescriptions(ConfigurationSection section) {
        ArrayList<CommandDescription> descriptions = new ArrayList<CommandDescription>();
        for (String s : section.getKeys(false))
            descriptions.add(new CommandDescription(section.getConfigurationSection(s)));
        return descriptions;
    }

}
