/**
 * 
 */
package com.bukkitarena.configuration;

import java.io.File;
import java.io.IOException;

import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.configuration.file.YamlConfiguration;

import com.bukkitarena.util.NamedObject;

/**
 * @author Nate Mortensen
 * 
 */
public abstract class EasyConfiguration implements NamedObject {
	ConfigurationSection config;
	String name;

	public int compareTo(String o) {
		return name.compareTo(o);
	}

	public void load(File file) {
		try {
			// Only creates the file if it doesn't already exist.
			file.createNewFile();
		} catch (IOException e) {
			e.printStackTrace();
		}
		load((ConfigurationSection) YamlConfiguration.loadConfiguration(file));
	}

	public void load(ConfigurationSection config) {
		this.config = config;
		name = config.getName();
		LoadingImpl.load(this, config);
	}
	public void inherit() {
		LoadingImpl.inherit(this);
	}
	public void inherit(ConfigurationSection c) {
		LoadingImpl.inherit(this, c);
	}
	public void inherit(Object other) {
		LoadingImpl.inheritFrom(this, other);
	}
	public void inherit(String path) {
		ConfigurationSection c = config.getParent().getConfigurationSection(path);
		if (c == null){
			throw new InvalidConfigurationException("Unable to inherit from the section: \'"+getConfig().getCurrentPath()+"."+path+"\' as the section doesn't exist.");
		}
		inherit(c);
	}

	public void save() {
		LoadingImpl.save(this, config);
	}

	public String getName() {
		return name;
	}

	public ConfigurationSection getConfig() {
		return config;
	}
}
