package com.bukkitarena.configuration.serialization;

import org.bukkit.configuration.ConfigurationSection;

public class NativeSerializer implements Serializer {

	@Override
	public void serialize(ConfigurationSection c, String path, Object obj) {
		Class<?> clazz = obj.getClass();
		if (clazz.equals(Boolean.TYPE)) {
			c.set(path, new Boolean(obj.toString()).booleanValue());
			return;
		}
		if (clazz.equals(Integer.TYPE)) {
			c.set(path, new Integer(obj.toString()).intValue());
			return;
		}
		if (clazz.equals(Long.TYPE)) {
			c.set(path, new Long(obj.toString()).longValue());
			return;
		}
		if (clazz.equals(Float.TYPE)) {
			c.set(path, new Float(obj.toString()).floatValue());
			return;
		}
		if (clazz.equals(Double.TYPE)) {
			c.set(path, new Double(obj.toString()).doubleValue());
			return;
		}
		if (clazz.equals(Byte.TYPE)) {
			c.set(path, new Byte(obj.toString()).byteValue());
			return;
		}
		if (clazz.equals(Short.TYPE)) {
			c.set(path, new Short(obj.toString()).shortValue());
			return;
		}
		//Anything else, this covers Strings and Collections.
		c.set(path, obj);
		
		
	}

	@Override
	public Object deserialize(ConfigurationSection c, String path) {
		return c.get(path);
	}

}
