/**
 * 
 */
package com.bukkitarena.entity;

import java.util.HashMap;

import org.bukkit.Location;
import org.bukkit.entity.LivingEntity;

import com.bukkitarena.arena.Arena;

/**
 * @author Nate Mortensen
 * 
 */
public class ArenaEntity {
    int kills = 0;
    int score = 0;
    int damage = 0;
    int maxHealth;
    LivingEntity entity;
    Arena arena;
    HashMap<String, Object> metadata = new HashMap<String, Object>();

    public ArenaEntity(LivingEntity e, Arena a, int health, int damageval) {
        entity = e;
        arena = a;
        e.setHealth(health);
        maxHealth = health;
        damage = damageval;
    }

    public ArenaEntity(LivingEntity e, Arena a) {
        entity = e;
        arena = a;
    }

    public int getMaxHealth() {
        return maxHealth;
    }

    public Arena getArena() {
        return arena;
    }

    public int getHealth() {
        return entity.getHealth();
    }

    public void setHealth(int val) {
        entity.setHealth(val);
    }

    public Location getLocation() {
        return entity.getLocation();
    }

    /**
     * @return the kills
     */
    public int getKills() {
        return kills;
    }

    /**
     * @param kills
     *            the kills to set
     */
    public void setKills(int kills) {
        this.kills = kills;
    }

    /**
     * @return the score
     */
    public int getScore() {
        return score;
    }

    /**
     * @param score
     *            the score to set
     */
    public void setScore(int score) {
        this.score = score;
    }

    /**
     * @return the damage
     */
    public int getDamage() {
        return damage;
    }

    /**
     * @param damage
     *            the damage to set
     */
    public void setDamage(int damage) {
        this.damage = damage;
    }

    public LivingEntity getEntity() {
        return entity;
    }

}
