/**
 * 
 */
package com.bukkitarena.event;

import java.lang.reflect.Method;

import org.bukkit.event.Event;
import org.bukkit.event.Listener;

import com.bukkitarena.arenatype.ArenaType;

/**
 * @author Nate Mortensen
 * 
 */
public class ArenaEventExecutor {
    Listener l;
    Method m;
    ArenaType a;
    Class<? extends Event> clazz;

    public ArenaEventExecutor(Listener l, Method m, Class<? extends Event> clazz, ArenaType a) {
        this.l = l;
        this.m = m;
        this.clazz = clazz;
        this.a = a;
    }

    public void execute(Event e) {
        try {
            if (clazz.isAssignableFrom(e.getClass()))
                m.invoke(l);
        } catch (Throwable throwable) {
            throwable.printStackTrace();
        }
    }

    public Listener getListener() {
        return l;
    }

    public Method getMethod() {
        return m;
    }

    public ArenaType getArenaType() {
        return a;
    }

    public Class<? extends Event> getEvent() {
        return clazz;
    }

}
