/**
 * 
 */
package com.bukkitarena.event.entity;

import org.bukkit.event.Cancellable;
import org.bukkit.event.HandlerList;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;

import com.bukkitarena.entity.ArenaEntity;

/**
 * @author Nate Mortensen
 * 
 */
public class ArenaEntityDamageEvent extends ArenaEntityEvent implements Cancellable {

    public static HandlerList handlers = new HandlerList();
    boolean cancelled;
    DamageCause cause;
    int damage;

    public ArenaEntityDamageEvent(ArenaEntity e, DamageCause cause, int damage) {
        super(e);
        this.cause = cause;
        this.damage = damage;
    }

    public DamageCause getCause() {
        return cause;
    }

    public HandlerList getHandlers() {
        return handlers;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.bukkit.event.Cancellable#isCancelled()
     */
    @Override
    public boolean isCancelled() {
        return cancelled;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.bukkit.event.Cancellable#setCancelled(boolean)
     */
    @Override
    public void setCancelled(boolean cancelled) {
        this.cancelled = cancelled;

    }

    public int getDamage() {
        return damage;
    }

    public void setDamage(int newval) {
        damage = newval;
    }

}
