/**
 * 
 */
package com.bukkitarena.objective;

import org.bukkit.block.Block;

import com.bukkitarena.event.objective.BlockObjectiveBreakEvent;
import com.bukkitarena.event.objective.BlockObjectiveClickEvent;

/**
 * @author Nate Mortensen
 * 
 */
public abstract class MultiBlockObjective implements BlockObjective {
    Block[] blocks;
    int score;

    public MultiBlockObjective(int score, Block[] blocks) {
        this.blocks = blocks;
        this.score = score;
    }

    public boolean contains(Block b) {
        for (Block block : blocks)
            if (block.equals(b))
                return true;
        return false;
    }

    public void setScore(int score) {
        this.score = score;
    }

    public int getScore() {
        return score;
    }

    public Block[] getBlocks() {
        return blocks;
    }

}
