/**
 * 
 */
package com.bukkitarena.playerclass;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import com.bukkitarena.BukkitArena;

/**
 * @author Nate Mortensen
 * 
 */
public class ClassManager {
    List<ClassSet> classSets = new ArrayList<ClassSet>();
    List<PlayerClass> classes = new ArrayList<PlayerClass>();
    FileConfiguration config;
    File file;

    public ClassManager() {
        file = new File(BukkitArena.getFolder() + "classes.yml");
        config = YamlConfiguration.loadConfiguration(file);
        loadClasses();
        loadSets();

    }

    private void loadClasses() {
        for (String s : config.getConfigurationSection("classes").getKeys(false))
            classes.add(new PlayerClass(config.getConfigurationSection("classes." + s)));
    }

    private void loadSets() {
        for (String s : config.getConfigurationSection("sets").getKeys(false))
            classSets.add(new ClassSet(config.getConfigurationSection("sets." + s)));
    }

    public ClassSet getClassSet(String name) {
        for (ClassSet a : classSets)
            if (a.equals(name))
                return a;
        return null;
    }

    public PlayerClass getClass(String name) {
        for (PlayerClass clazz : classes)
            if (clazz.getName().equals(name))
                return clazz;
        return null;
    }

}