/**
 * 
 */
package com.bukkitarena.playerclass;

import java.util.ArrayList;
import java.util.List;

import org.bukkit.configuration.ConfigurationSection;

import com.bukkitarena.BukkitArena;
import com.bukkitarena.entity.ArenaPlayer;
import com.bukkitarena.util.SortedNamedObjectList;

/**
 * @author Nate Mortensen
 * 
 */
public class ClassSet {
    SortedNamedObjectList<PlayerClass> classes;

    public ClassSet(ConfigurationSection c) {
        for (String s : c.getKeys(false))
            classes.add(BukkitArena.getClassManager().getClass(s));
    }

    public boolean isEmpty() {
        return (classes == null);
    }

    public PlayerClass getClass(String name) {
        for (PlayerClass clazz : classes) {
            if (clazz.getName().equalsIgnoreCase(name))
                return clazz;
        }
        return null;
    }

    public boolean hasClass(String name) {
        return (getClass(name) == null ? false : true);
    }

    public void addClass(PlayerClass clazz) {
        classes.add(clazz);
    }

    public static List<ArenaPlayer> getPlayersWithClass(List<ArenaPlayer> p, PlayerClass c) {
        ArrayList<ArenaPlayer> newlist = new ArrayList<ArenaPlayer>();
        for (ArenaPlayer player : p) {
            if (player.getPlayerClass().equals(c))
                newlist.add(player);
        }
        return newlist;
    }

}
