package com.bukkitarena.regionregenerator;

import java.util.ArrayList;

import org.bukkit.Location;

import com.bukkitarena.util.ComputeUtil;


public class RegeneratingRegion {
	ArrayList<Change> changes = new ArrayList<Change>();

	boolean tracking;
	Location p1,p2;
	

	
	public RegeneratingRegion(Location p1, Location p2) {
        // A nice and simple way to do the cuboid.
        double minx, miny, minz, maxx, maxy, maxz;
        minx = ComputeUtil.getMinimum(p1.getX(), p2.getX());
        miny = ComputeUtil.getMinimum(p1.getY(), p2.getY());
        minz = ComputeUtil.getMinimum(p1.getZ(), p2.getZ());
        maxx = ComputeUtil.getMaximum(p1.getX(), p2.getX());
        maxy = ComputeUtil.getMaximum(p1.getY(), p2.getZ());
        maxz = ComputeUtil.getMaximum(p1.getZ(), p2.getZ());
        p1 = new Location(p1.getWorld(), minx, miny, minz);
        p2 = new Location(p1.getWorld(), maxx, maxy, maxz);
	}


	public void addChange(Change c) {
		if (tracking && !changes.contains(c)) {
			changes.add(c);
		}
	}

	public void reset(){
		for (Change change : changes) {
			change.revert();
		}
		changes.clear();
	}

	public boolean isTracking() {
		return tracking;
	}
	public boolean toggleTracking() {
		return (tracking = !tracking);
	}
	
	public boolean contains(Location loc) {
        if (loc.getX() >= p1.getX() && loc.getY() >= p1.getY() && loc.getZ() >= p1.getZ())
            if (loc.getX() <= p2.getX() && loc.getY() <= p2.getY() && loc.getZ() <= p2.getZ())
                return true;
        return false;
	}


}
