package com.bukkitarena.regionregenerator;

import org.bukkit.Material;
import org.bukkit.block.BlockState;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;
import org.bukkit.event.block.BlockBurnEvent;
import org.bukkit.event.block.BlockFadeEvent;
import org.bukkit.event.block.BlockFormEvent;
import org.bukkit.event.block.BlockFromToEvent;
import org.bukkit.event.block.BlockPhysicsEvent;
import org.bukkit.event.block.BlockPlaceEvent;
import org.bukkit.event.block.LeavesDecayEvent;
import org.bukkit.event.block.SignChangeEvent;
import org.bukkit.event.player.PlayerInteractEvent;

public class RegionListener implements Listener{
	RegionManager rm;
	
	public RegionListener(RegionManager rm) {
		this.rm = rm;
	}
	
	@EventHandler(ignoreCancelled = true)
	public void onBlockBreak(BlockBreakEvent e) {
		handle(e.getBlock().getState());
	}
	@EventHandler(ignoreCancelled = true)
	public void onBlockPlace(BlockPlaceEvent e) {
		handle(e.getBlockReplacedState());
	}
	@EventHandler(ignoreCancelled = true)
	public void onBlockPhsyics(BlockPhysicsEvent e) {
		handle(e.getBlock().getState());
	}
	@EventHandler(ignoreCancelled = true)
	public void onBlockFade(BlockFadeEvent e) {
		handle(e.getBlock().getState());
	}
	@EventHandler(ignoreCancelled = true)
	public void onBlockFromTo(BlockFromToEvent e) {
		handle(e.getToBlock().getState());
	}
	@EventHandler(ignoreCancelled = true)
	public void onBlockBurn(BlockBurnEvent e) {
		handle(e.getBlock().getState());
	}
	@EventHandler(ignoreCancelled = true)
	public void onBlockForm(BlockFormEvent e) {
		handle(e.getBlock().getState());
	}
	@EventHandler(ignoreCancelled = true)
	public void onLeafDecay(LeavesDecayEvent e) {
		handle(e.getBlock().getState());
	}
	@EventHandler(ignoreCancelled = true)
	public void onSignChange(SignChangeEvent e) {
		handle(e.getBlock().getState());
	}
	@EventHandler(ignoreCancelled = true)
	public void onPlayerInteract(PlayerInteractEvent e) {
		if (e.getClickedBlock() != null && e.getClickedBlock().getType() == Material.LEVER) {
			handle(e.getClickedBlock().getState());
		}
	}
	public void handle(BlockState newstate) {
		RegeneratingRegion r = rm.getRegion(newstate.getLocation());
		if (r != null) {
			r.addChange(new Change(newstate));
		}
	}


}
