/**
 * 
 */
package com.bukkitarena.runnable;

import com.bukkitarena.BukkitArena;

/**
 * @author Nate Mortensen
 * 
 */
public abstract class BARunnable implements Runnable {
    private int id;

    public int getId() {
        return id;
    }

    public void schedule(long time) {
        id = BukkitArena.getBukkitScheduler().scheduleSyncDelayedTask(BukkitArena.getInstance(), this, time);
    }

    public void scheduleRepeating(long start, long delay) {
        id = BukkitArena.getBukkitScheduler().scheduleSyncRepeatingTask(BukkitArena.getInstance(), this, start, delay);
    }

    public void scheduleAsync(long start) {
        id = BukkitArena.getBukkitScheduler().scheduleAsyncDelayedTask(BukkitArena.getInstance(), this, start);
    }

    public void cancel() {
        BukkitArena.getScheduler().cancel(this);
    }

}
