/**
 * 
 */
package com.bukkitarena.runnable;

import java.util.ArrayList;

import org.bukkit.Bukkit;

/**
 * @author Nate Mortensen
 * 
 */
public class BAScheduler {
    ArrayList<BARunnable> runnables = new ArrayList<BARunnable>();

    public BAScheduler() {
    }

    public void schedule(BARunnable runnable, int start) {
        runnable.schedule(start);
        runnables.add(runnable);
    }

    public void scheduleRepeating(BARunnable runnable, int start, int delay) {
        runnable.scheduleRepeating(start, delay);
        runnables.add(runnable);
    }

    public void cancel(BARunnable runnable) {
        if (!runnables.contains(runnable))
            return;
        remove(runnable);
    }

    private void remove(BARunnable runnable) {
        Bukkit.getScheduler().cancelTask(runnable.getId());
        runnables.remove(runnable);
    }

    public void clear() {
        for (BARunnable runnable : runnables) {
            remove(runnable);

        }
    }
}
