/**
 * 
 */
package com.bukkitarena.runnable;

import java.util.ArrayList;
import java.util.HashMap;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.entity.Player;

import com.bukkitarena.BukkitArena;
import com.bukkitarena.Msg;
import com.bukkitarena.arena.Arena;
import com.bukkitarena.objective.RegionObjective;

/**
 * @author Nate Mortensen
 * 
 */
public class MovementCheck extends BARunnable {

    HashMap<Player, Location> previous = new HashMap<Player, Location>();
    HashMap<Player, ArrayList<RegionObjective>> objectives = new HashMap<Player, ArrayList<RegionObjective>>();

    public void run() {
        for (Player p : Bukkit.getServer().getOnlinePlayers()) {
            for (Arena a : BukkitArena.getArenaManager().getArenas()) {
                if (!a.isRunning())
                    continue;
                if (!a.containsPlayer(p) && a.getRegion().containsLocation(p.getLocation())) {
                    p.teleport(previous.get(p));
                    p.sendMessage(Msg.ARENA_ENTER_FAIL);
                }
                if (a.containsPlayer(p)) {
                    if (!a.getRegion().containsLocation(p.getLocation())) {
                        p.teleport(previous.get(p));
                        p.sendMessage(Msg.ARENA_LEAVE_FAIL);
                    }
                    for (RegionObjective obj : a.getRegionObjectives()) {
                        if (obj.containsLocation(p.getLocation()) && !objectives.get(p).contains(obj)) {
                            objectives.get(p).add(obj);

                        }
                        if (!obj.containsLocation(p.getLocation()) && objectives.get(p).contains(obj)) {

                        }

                    }
                }
            }
            addPlayer(p);
        }

    }

    public void addPlayer(Player p) {
        // If they're falling or were launched, we don't want to send them right
        // back to their previous state, otherwise they get stuck on boxes and
        // stuff.
        if (p.getFallDistance() == 0) {
            previous.put(p, p.getLocation());
            return;
        }
    }

    public void removePlayer(Player p) {
        previous.remove(p);
    }

    public void clearObjectives(Player p) {
        objectives.remove(p);
    }

}
