/**
 * 
 */
package com.bukkitarena.spawning;

import java.util.HashMap;
import java.util.Map;

import org.bukkit.Bukkit;
import org.bukkit.Location;
import org.bukkit.World;
import org.bukkit.configuration.serialization.ConfigurationSerializable;

/**
 * @author Nate Mortensen
 * 
 */
public class ConfigurationSerializableLocation extends Location implements ConfigurationSerializable {

    /**
     * @param world
     * @param x
     * @param y
     * @param z
     */
    public ConfigurationSerializableLocation(World world, double x, double y, double z) {
        super(world, x, y, z);
    }

    public ConfigurationSerializableLocation(Map<String, Object> map) {
        super(Bukkit.getServer().getWorld((String) map.get("world")), ((Integer) map.get("x")).intValue(), ((Integer) map.get("y")).intValue(), ((Integer) map.get("z")).intValue());
    }

    public Map<String, Object> serialize() {
        HashMap<String, Object> map = new HashMap<String, Object>();
        map.put("x", getX());
        map.put("y", getY());
        map.put("z", getZ());
        map.put("world", getWorld().getName());
        return map;
    }

    public static ConfigurationSerializableLocation deserialize(Map<String, Object> map) {
        return new ConfigurationSerializableLocation(map);
    }

    public static ConfigurationSerializableLocation valueOf(Map<String, Object> map) {
        return deserialize(map);
    }
}
