/**
 * 
 */
package com.bukkitarena.spawning;

import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.EntityType;

import com.bukkitarena.configuration.EasyConfiguration;
import com.bukkitarena.configuration.Load;

/**
 * @author Nate Mortensen
 * 
 */
public class EntityGroup extends EasyConfiguration {

    @Load
    int amount;
    @Load
    int damagescale = 100;
    @Load
    int ressistancescale = 100;

    EntityType t;

    /**
     * @param c
     */
    public EntityGroup(ConfigurationSection c) {
        load(c);
        t = Enum.valueOf(EntityType.class, c.getName());
    }

    public EntityGroup(EntityType type, int amount) {
        this.t = type;
        this.amount = amount;
    }

    public void add(int i) {
        amount += i;
    }

    public void remove(int i) {
        amount -= i;
    }

    public EntityType getType() {
        return t;
    }

    /**
     * @return the amount
     */
    public int getAmount() {
        return amount;
    }

    /**
     * @param amount
     *            the amount to set
     */
    public void setAmount(int amount) {
        this.amount = amount;
    }

    /**
     * @return the damagescale
     */
    public int getDamagescale() {
        return damagescale;
    }

    /**
     * @param damagescale
     *            the damagescale to set
     */
    public void setDamagescale(int damagescale) {
        this.damagescale = damagescale;
    }

    /**
     * @return the ressistancescale
     */
    public int getRessistancescale() {
        return ressistancescale;
    }

    /**
     * @param ressistancescale
     *            the ressistancescale to set
     */
    public void setRessistancescale(int ressistancescale) {
        this.ressistancescale = ressistancescale;
    }

}
