/**
 * 
 */
package com.bukkitarena.spawning;

import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import org.bukkit.configuration.ConfigurationSection;
import org.bukkit.entity.EntityType;

import com.bukkitarena.configuration.EasyConfiguration;
/**
 * @author Nate Mortensen
 * 
 */
public class Wave extends EasyConfiguration {

    ArrayList<EntityGroup> groups = new ArrayList<EntityGroup>();

    public Wave(ConfigurationSection c) {
        load(c);
        for (String s : c.getConfigurationSection("entities").getKeys(false))
            groups.add(new EntityGroup(c.getConfigurationSection("entities." + s)));

    }

    public void spawnWave(List<Spawnpoint> s) {
        ArrayList<EntityType> mobs = getListEntities();
        // Scramble the spawnpoints.
        Collections.shuffle(s);
        Iterator<EntityType> iterator = mobs.iterator();
        while (iterator.hasNext())
            for (Spawnpoint spawn : s)
                spawn.getWorld().spawnEntity(spawn, iterator.next());
    }

    public ArrayList<EntityType> getListEntities() {
        ArrayList<EntityType> list = new ArrayList<EntityType>();
        for (EntityGroup g : groups)
            for (int i = 0; i < g.getAmount(); i++)
                list.add(g.getType());
        return list;
    }

    public void addEntities(EntityType t, int amount) {
        getEntityGroup(t).add(amount);
    }

    public void removeEntities(EntityType t, int amount) {
        getEntityGroup(t).remove(amount);
    }

    public EntityGroup getEntityGroup(EntityType type) {
        for (EntityGroup e : groups)
            if (e.getType() == type)
                return e;
        return new EntityGroup(type, 0);
    }

}
