/**
 * 
 */
package com.bukkitarena.spawning;

import java.io.File;
import java.util.ArrayList;
import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;

import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

import com.bukkitarena.BukkitArena;

/**
 * @author Nate Mortensen
 * 
 */
public class WaveManager {
    SortedSet<WaveSet> wavesets = new TreeSet<WaveSet>();
    List<Wave> waves = new ArrayList<Wave>();
    FileConfiguration config;

    public WaveManager() {
        config = YamlConfiguration.loadConfiguration(new File(BukkitArena.getFolder() + "waves.yml"));
        // They have to be called in this order, as the managers rely on the
        // waves.
        loadWaves();
        loadManagers();

    }

    private void loadWaves() {
        for (String s : config.getConfigurationSection("waves").getKeys(false))
            waves.add(new Wave(config.getConfigurationSection("waves." + s)));
    }

    private void loadManagers() {
        for (String s : config.getConfigurationSection("sets").getKeys(false))
            wavesets.add(new WaveSet(config.getConfigurationSection("sets." + s)));
    }

    public WaveSet getWaveSet(String name) {
        for (WaveSet a : wavesets)
            if (a.equals(name))
                return a;
        return null;
    }

    public Wave getWave(String name) {
        for (Wave wave : waves)
            if (wave.getName().equals(name))
                return wave;
        return null;
    }

}
