/**
 * 
 */
package com.bukkitarena.team;

import org.bukkit.ChatColor;
import org.bukkit.DyeColor;
import org.bukkit.inventory.ItemStack;

/**
 * @author Nate Mortensen
 * 
 */
public enum TeamColor {
    LIGHT_GRAY(ChatColor.GRAY), GRAY(ChatColor.DARK_GRAY), BLACK(ChatColor.BLACK), RED(ChatColor.RED), ORANGE(ChatColor.GOLD), YELLOW(ChatColor.YELLOW), LIME(ChatColor.GREEN), GREEN(ChatColor.DARK_GREEN), LIGHT_BLUE(ChatColor.BLUE), CYAN(ChatColor.AQUA), PURPLE(ChatColor.DARK_PURPLE), MAGENTA(ChatColor.DARK_PURPLE), PINK(ChatColor.LIGHT_PURPLE), BLUE(ChatColor.DARK_BLUE),
    // Strikethrough to represent that there isn't a color code for brown. No
    // love for brown.
    BROWN(ChatColor.STRIKETHROUGH);

    ChatColor color;

    private TeamColor(ChatColor c) {
        color = c;
    }

    public ItemStack getHelmet() {
        return new ItemStack(1, Enum.valueOf(DyeColor.class, this.toString()).getData());
    }

    public ChatColor getColor() {
        return color;
    }

    @Override
    public String toString() {
        String name = name();
        name = name.replace('_', ' ');
        char firstChar = name.charAt(0);
        name = name.substring(1);
        name = firstChar + name;
        return name;
    }

}
