/**
 * 
 */
package com.bukkitarena.util;

/**
 * @author Nate Mortensen
 * 
 */
public class BoundedInteger {

    int min;
    int max;
    int value;
    int range;

    public BoundedInteger(int start, int min, int max) {
        value = start;
        this.min = min;
        this.max = max;
        range = max - min;
    }

    public BoundedInteger(int min, int max) {
        this.min = value = min;
        this.max = max;
        range = max - min;
    }

    public BoundedInteger(int max) {
        this.min = value = 0;
        this.max = max;
        range = max - min;
    }

    /**
     * This increases the value of this bounded integer by the specified amount.
     * E.g. if you want to add 7, you pass in 7 as an argument.
     * 
     * 
     * @param amount
     *            The amount this bounded integer will be decreased by.
     */
    public void increment(int amount) {
        change(amount);
    }

    /**
     * Increases the value of this bounded integer by 1;
     * 
     */
    public void increment() {
        change(1);
    }

    /**
     * Decreased the value of this bounded integer by 1.
     * 
     */
    public void decrement() {
        change(-1);
    }

    /**
     * This decreases the value of this bounded integer by the specified amount.
     * E.g. if you want to subtract 7, you pass in 7 as an argument.
     * 
     * 
     * @param amount
     *            The amount this bounded integer will be decreased by.
     */
    public void decrement(int amount) {
        change(amount * -1);
    }

    private void change(int amount) {
        value += amount;
        clamp();

    }

    private void clamp() {
    	value %= range;
    	if (value < 0)
    		value += range;
    }

    public void setValue(int newValue) {
        value = newValue;
        clamp();
    }

    public int value() {
        return value;
    }

}
