/**
 * 
 */
package com.bukkitarena.util;

import java.io.File;
import java.io.IOException;

import org.bukkit.configuration.file.FileConfiguration;
import org.bukkit.configuration.file.YamlConfiguration;

/**
 * @author Nate Mortensen
 * 
 *         Some useful methods for files.
 * 
 */
public class FileUtil {

    /**
     * @param path
     *            The path of requested file or directory.
     * @return File with specified path. If the file or any of it's directories
     *         didn't exist, it created them.
     */
    public static File getFile(String path) {
        File file = new File(path);
        file.mkdirs();
        if (!file.exists()) {
            if (!file.isDirectory()) {
                try {
                    file.createNewFile();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

        return file;
    }

    /**
     * @param t
     *            ArenaType that is calling this method.
     * @param name
     *            Name of the file, without the file type at the end.
     * @return FileConfiguration file with specified player, that is unique to
     *         specified ArenaType.
     */
    public static FileConfiguration loadConfiguration(String folder, String name) {
        File f = getFile(folder);
        return YamlConfiguration.loadConfiguration(new File(f, name + ".yml"));

    }

}
