/**
 * 
 */
package com.bukkitarena.util;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

import org.bukkit.inventory.ItemStack;

/**
 * @author Nate Mortensen
 * 
 */
public class ItemUtil {

    static ArrayList<Integer> chestplates = new ArrayList<Integer>(Arrays.asList(299, 303, 307, 311, 315));
    static ArrayList<Integer> leggings = new ArrayList<Integer>(Arrays.asList(300, 304, 308, 312, 316));
    static ArrayList<Integer> boots = new ArrayList<Integer>(Arrays.asList(301, 305, 309, 313, 317));

    // static ArrayList<Integer> swords = new
    // ArrayList<Integer>(Arrays.asList(267,268,272,276,283));

    public static boolean isChestPlate(ItemStack i) {
        return chestplates.contains(i.getTypeId());
    }

    public static boolean isLegging(ItemStack i) {
        return leggings.contains(i.getTypeId());
    }

    public static boolean isBoots(ItemStack i) {
        return boots.contains(i.getTypeId());
    }

    /**
     * @param items
     *            A hashmap of the item ID's and the amount of each.
     * @return a list of ItemStack's with parameters matching those defined in
     *         the hashmap.
     */
    public static List<ItemStack> intsToItemStacks(HashMap<Integer, Integer> items) {
        ArrayList<ItemStack> stacks = new ArrayList<ItemStack>();

        for (int id : items.keySet()) {
            stacks.add(new ItemStack(id, items.get(id)));
        }
        return stacks;

    }

}
