/**
 * 
 */
package com.bukkitarena.util;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;



/**
 * @author Nate Mortensen
 * 
 */
public class SortedNamedObjectList<T extends NamedObject> implements Iterable<T> {

    TreeMap<String, T> map = new TreeMap<String, T>();

    public void add(T t) {
        map.put(t.getName(), t);
    }

    public void remove(T t) {
        map.remove(t.getName());
    }

    public void remove(String name) {
        map.remove(name);
    }

    public T get(String name) {
        return map.get(name);
    }

    public int size() {
        return map.size();
    }

    public void clear() {
        map.clear();
    }

    public List<T> asList() {
        return new ArrayList<T>(map.values());
    }

    @SuppressWarnings("unchecked")
    public Map<String, T> asMap() {
        return (Map<String, T>) map.clone();
    }

    public Iterator<T> iterator() {
        return map.values().iterator();
    }

    public void addAll(Collection<T> collection) {
        for (T t : collection) {
            add(t);
        }
    }

}
